print '           .ymNy`o+                      .:`ooo.'
print '         .NMMM*  :Md.                   yM` `NMMdo'
print '         MMMMd   `MMh                  hMm   :@MMMh'
print '        :MMMMo   .MMM:                sMMd    mMMMM`'
print '         *NMMs   yMMMy               .MMMN    @MMMo'
print '          `+hd. oMNdy`               -dMMMo. :MMh:'
print '`-              ``                    `*MM* .**`'
print ' os`                                                   .+`'
print '  .+y-                                                `oh'
print '   `yy+\.                                          :y+``'
print '     `-oMd++-                                    :+yN-:'
print '       `:./N+Ndhs\\:-....-/ohhdyo/-.     .-:+ohNs/+.s`'
print '         `+\hy/Ny:Mh+MN:MmoMMomMM/Nd+MM+Mm:Md.o/.+-`'
print '            `+o.mhomoMy/:+`yo`-s/.+.ohNyy-m::Ny/`'
print '                `-=o:.hhhh+N//+y+hN/Nh:hy-+-`'
print ' '
print ' 2022, CheshireCat, going back to her roots !'
print ' '
;=============================================================
; Thanks to Roudoudou for RASM ;-)
; Thanks to Norecess for http://norecess.cpcscene.net/advancedmemoryusage.html
; Thanks to Quasar for http://quasar.cpcscene.net/doku.php?id=assem:crtc
; Thanks to Juan Carlos Gonzalez Amestoy for Retro Virtual Machine
; Thanks to Golem13, GurneyH, Siko & Roudoudou for some tips on coding
; Thanks to Gyneceon for his CPCEC
; Thanks to Hwikaa for his help on figuring out how to bend this f*cking CRTC
; Thanks to Targhan for his player & tracker https://www.julien-nevo.com/arkostracker/
; Thanks to Madram for https://cpcrulez.fr/coding_amslive04-z80.htm
; Thanks to Ast for https://amstradplus.forumforever.com/t314-Programmation-des-Rom-Ram-sur-Cpc-Cpc-Plus.htm
; Thanks to me ^_^ for https://cpcrulez.fr/hardware-interface-ramcard-memcard-ram7.htm
; Thanks to Longshot for the Compendium : http://www.logonsystem.fr/html/downloadlogon.htm
;=============================================================

    include 'std/macros.asm'
    include 'std/timings.asm'
    include 'std/crtc.asm'
    include 'std/gatearray.asm'
;    include 'playcity.asm'
;    include 'RxMManager.asm'

StartScroll equ 48
ScrollHeight equ 240
Reg2        equ 51

    print '########################################################################'
start:
    org #3000

    ld b,1024/16+1
LoopFond:
    push bc
    ld a,'U'
    call #bb5a
    ld a,'N'
    call #bb5a
    ld a,' '
    call #bb5a
    ld a,'S'
    call #bb5a
    ld a,'C'
    call #bb5a
    ld a,'R'
    call #bb5a
    ld a,'O'
    call #bb5a
    ld a,'L'
    call #bb5a
    ld a,'L'
    call #bb5a
    ld a,' '
    call #bb5a
    ld a,'H'
    call #bb5a
    ld a,'A'
    call #bb5a
    ld a,'R'
    call #bb5a
    ld a,'D'
    call #bb5a
    ld a,'!'
    call #bb5a
    ld a,' '
    call #bb5a
    pop bc
    djnz LoopFond

    di

    setborder ink6
    outcrtc 3,6
    outcrtc 2,Reg2
    outcrtc 1,(Reg2-1)

    WAIT_VSYNC

    FINDFIRSTNOP
boucleecran:
    TIMING_START_NOPS_COUNT 0
    ld bc,#bc03 ; 3
    out (c),c   ; 4
    inc b       ; 1
    ld c,4      ; 2
    ld d,5      ; 2
    ld e,6      ; 2

    ld a,ScrollHeight     ; 2

    out (c),d   ; 4

    timing_locate StartScroll,(Reg2-1)+5-4-3

Saut_State:
    jp state1

state1: ; 4.25
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
.loop:
    ticker start,sizeouts2
    nop
    out (c),c
    out (c),d
    dec a
    ticker stop,sizeouts2
    timing_delay 64-sizeouts2
    ticker start,sizeouts2
    out (c),c
    out (c),d
    ticker stop,sizeouts2
    timing_delay 64-4-sizeouts2
    dec a
    jp nz,.loop
    ld hl,state2
    nop:nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state2: ; 4.5
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop
.loop:
    ticker start,sizeouts2
    out (c),c
    out (c),d
    ticker stop,sizeouts2
    timing_delay 64-4-sizeouts2
    dec a
    jp nz,.loop
    ld hl,state3
    nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state3: ; 4.75
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
.loop:
    ticker start,sizeouts3
    nop:nop
    out (c),c
    out (c),d
    dec a
    ticker stop,sizeouts3
    timing_delay 64-sizeouts3
    ticker start,sizeouts3
    nop
    out (c),c
    out (c),d
    ticker stop,sizeouts3
    timing_delay 64-4-sizeouts3
    dec a
    jp nz,.loop
    ld hl,state4
    nop:nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state4: ; 5
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop
.loop:
    ticker start,sizeouts
    out (c),d
    out (c),e
    ticker stop,sizeouts
    timing_delay 64-4-sizeouts
    dec a
    jp nz,.loop
    ld hl,state5
    nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state5: ; 5.25
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop
.loop:
    ticker start,sizeouts2
    nop
    out (c),d
    out (c),e
    dec a
    ticker stop,sizeouts2
    timing_delay 64-sizeouts2
    ticker start,sizeouts2
    out (c),d
    out (c),e
    ticker stop,sizeouts2
    timing_delay 64-4-sizeouts2
    dec a
    jp nz,.loop
    ld hl,state6
    nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state6: ; 5.5
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop
    nop
.loop:
    ticker start,sizeouts2
    out (c),d
    out (c),e
    ticker stop,sizeouts2
    timing_delay 64-4-sizeouts2
    dec a
    jp nz,.loop
    ld hl,state7
    nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state7: ; 5.75
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop
.loop:
    ticker start,sizeouts3
    nop:nop
    out (c),d
    out (c),e
    dec a
    ticker stop,sizeouts3
    timing_delay 64-sizeouts3
    ticker start,sizeouts3
    nop
    out (c),d
    out (c),e
    ticker stop,sizeouts3
    timing_delay 64-4-sizeouts3
    dec a
    jp nz,.loop
    ld hl,state8
    nop:nop:nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

state8: ; 6
    TIMING_START_NOPS_COUNT StartScroll*64+(Reg2-1)+5-4
    nop:nop:nop
.loop:
    ticker start,sizeouts3
    out (c),d
    out (c),e
    ticker stop,sizeouts3
    timing_delay 64-4-sizeouts3
    dec a
    jp nz,.loop
    ld hl,state1
    nop:nop:nop:nop
;    TIMING_START_NOPS_COUNT 164*64,45+5-4+3+6
    jp endboucle

endboucle:
    TIMING_START_NOPS_COUNT (startScroll+scrollHeight)*64+(Reg2-1)+5-4+1+3+3+6

    out (c),e   ; 4
cptframes:
    ld a,2     ; 2
    dec a       ; 1
    jr nz,.suite    ;3/2
    ld a,2     ; 2
    ld (cptframes+1),a  ; 4
    ld (saut_state+1),hl ;5
    jr endend   ; 3 -- 23
.suite:
    ld (cptframes+1),a  ; 4
    nop:nop:nop:nop:nop:nop:nop:nop:nop
endend:
    TIMING_START_NOPS_COUNT (startScroll+scrollHeight)*64+(Reg2-1)+5-4+1+3+3+6+23

    outcrtc 3,6

Reg13:
    ld a,0
    inc a
    ld (Reg13+1),a
    srl a
    srl a
    srl a
    srl a
    ld bc,#bc00+13
    out (c),c
    inc b
    out (c),a

    timing_locate 0,-3
    jp boucleecran






    print '########################################################################'
;################################################################################################
    header 'TIMING FUNCTIONS',$,#3FF0
;------------------------------------------------------------------------------------------------
    PUT_TIMING_FUNCTIONS
;------------------------------------------------------------------------------------------------
    footer 'TIMING FUNCTIONS',$,#3FF0
;################################################################################################

end:
    total_length equ end-start
    print '                Total length : ', {hex4} total_length
;    assert total_length<ob_total_maxlength, 'Final program is too big !'
;===============================================
SAVE 'test.bin',start,end-start,DSK,'scroll_pixel.dsk'
